diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/media.php ./wordpress-3.3/wp-admin/includes/media.php
*** ./wordpress-3.2.1/wp-admin/includes/media.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/media.php	2011-11-30 22:51:35.000000000 -0600
***************
*** 62,70 ****
   * @since 2.5.0
   */
  function the_media_upload_tabs() {
! 	global $redir_tab;
  	$tabs = media_upload_tabs();
  
  	if ( !empty($tabs) ) {
  		echo "<ul id='sidemenu'>\n";
  		if ( isset($redir_tab) && array_key_exists($redir_tab, $tabs) )
--- 62,77 ----
   * @since 2.5.0
   */
  function the_media_upload_tabs() {
! 	global $redir_tab, $is_iphone;
  	$tabs = media_upload_tabs();
  
+ 	if ( $is_iphone ) {
+ 		unset($tabs['type']);
+ 		$default = 'type_url';
+ 	} else {
+ 		$default = 'type';
+ 	}
+ 
  	if ( !empty($tabs) ) {
  		echo "<ul id='sidemenu'>\n";
  		if ( isset($redir_tab) && array_key_exists($redir_tab, $tabs) )
***************
*** 72,78 ****
  		elseif ( isset($_GET['tab']) && array_key_exists($_GET['tab'], $tabs) )
  			$current = $_GET['tab'];
  		else
! 			$current = apply_filters('media_upload_default_tab', 'type');
  
  		foreach ( $tabs as $callback => $text ) {
  			$class = '';
--- 79,85 ----
  		elseif ( isset($_GET['tab']) && array_key_exists($_GET['tab'], $tabs) )
  			$current = $_GET['tab'];
  		else
! 			$current = apply_filters('media_upload_default_tab', $default);
  
  		foreach ( $tabs as $callback => $text ) {
  			$class = '';
***************
*** 76,84 ****
  
  		foreach ( $tabs as $callback => $text ) {
  			$class = '';
  			if ( $current == $callback )
  				$class = " class='current'";
! 			$href = add_query_arg(array('tab'=>$callback, 's'=>false, 'paged'=>false, 'post_mime_type'=>false, 'm'=>false));
  			$link = "<a href='" . esc_url($href) . "'$class>$text</a>";
  			echo "\t<li id='" . esc_attr("tab-$callback") . "'>$link</li>\n";
  		}
--- 83,93 ----
  
  		foreach ( $tabs as $callback => $text ) {
  			$class = '';
+ 
  			if ( $current == $callback )
  				$class = " class='current'";
! 
! 			$href = add_query_arg(array('tab' => $callback, 's' => false, 'paged' => false, 'post_mime_type' => false, 'm' => false));
  			$link = "<a href='" . esc_url($href) . "'$class>$text</a>";
  			echo "\t<li id='" . esc_attr("tab-$callback") . "'>$link</li>\n";
  		}
***************
*** 274,280 ****
  			$content = $image_meta['caption'];
  	}
  
! 	$title = isset($desc) ? $desc : '';
  
  	// Construct the attachment array
  	$attachment = array_merge( array(
--- 283,290 ----
  			$content = $image_meta['caption'];
  	}
  
! 	if ( isset( $desc ) )
! 		$title = $desc;
  
  	// Construct the attachment array
  	$attachment = array_merge( array(
***************
*** 308,322 ****
   * @param unknown_type $content_func
   */
  function wp_iframe($content_func /* ... */) {
  ?>
- <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
- <html xmlns="http://www.w3.org/1999/xhtml" <?php do_action('admin_xml_ns'); ?> <?php language_attributes(); ?>>
- <head>
- <meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
  <title><?php bloginfo('name') ?> &rsaquo; <?php _e('Uploads'); ?> &#8212; <?php _e('WordPress'); ?></title>
  <?php
! wp_enqueue_style( 'global' );
! wp_enqueue_style( 'wp-admin' );
  wp_enqueue_style( 'colors' );
  // Check callback name for 'media'
  if ( ( is_array( $content_func ) && ! empty( $content_func[1] ) && 0 === strpos( (string) $content_func[1], 'media' ) )
--- 318,328 ----
   * @param unknown_type $content_func
   */
  function wp_iframe($content_func /* ... */) {
+ 	_wp_admin_html_begin();
  ?>
  <title><?php bloginfo('name') ?> &rsaquo; <?php _e('Uploads'); ?> &#8212; <?php _e('WordPress'); ?></title>
  <?php
! 
  wp_enqueue_style( 'colors' );
  // Check callback name for 'media'
  if ( ( is_array( $content_func ) && ! empty( $content_func[1] ) && 0 === strpos( (string) $content_func[1], 'media' ) )
***************
*** 347,359 ****
  </head>
  <body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?> class="no-js">
  <script type="text/javascript">
! //<![CDATA[
! (function(){
! var c = document.body.className;
! c = c.replace(/no-js/, 'js');
! document.body.className = c;
! })();
! //]]>
  </script>
  <?php
  	$args = func_get_args();
--- 353,359 ----
  </head>
  <body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?> class="no-js">
  <script type="text/javascript">
! document.body.className = document.body.className.replace('no-js', 'js');
  </script>
  <?php
  	$args = func_get_args();
***************
*** 373,417 ****
   *
   * @since 2.5.0
   */
! function media_buttons() {
! 	$do_image = $do_audio = $do_video = true;
! 	if ( is_multisite() ) {
! 		$media_buttons = get_site_option( 'mu_media_buttons' );
! 		if ( empty($media_buttons['image']) )
! 			$do_image = false;
! 		if ( empty($media_buttons['audio']) )
! 			$do_audio = false;
! 		if ( empty($media_buttons['video']) )
! 			$do_video = false;
! 	}
! 	$out = '';
! 
! 	if ( $do_image )
! 		$out .= _media_button(__('Add an Image'), 'images/media-button-image.gif?ver=20100531', 'image');
! 	if ( $do_video )
! 		$out .= _media_button(__('Add Video'), 'images/media-button-video.gif?ver=20100531', 'video');
! 	if ( $do_audio )
! 		$out .= _media_button(__('Add Audio'), 'images/media-button-music.gif?ver=20100531', 'audio');
! 
! 	$out .= _media_button(__('Add Media'), 'images/media-button-other.gif?ver=20100531', 'media');
! 
  	$context = apply_filters('media_buttons_context', __('Upload/Insert %s'));
  
! 	printf($context, $out);
  }
  add_action( 'media_buttons', 'media_buttons' );
  
! function _media_button($title, $icon, $type) {
! 	return "<a href='" . esc_url( get_upload_iframe_src($type) ) . "' id='add_$type' class='thickbox' title='$title'><img src='" . esc_url( admin_url( $icon ) ) . "' alt='$title' onclick='return false;' /></a>";
  }
  
! function get_upload_iframe_src($type) {
! 	global $post_ID, $temp_ID;
! 	$uploading_iframe_ID = (int) (0 == $post_ID ? $temp_ID : $post_ID);
! 	$upload_iframe_src = add_query_arg('post_id', $uploading_iframe_ID, 'media-upload.php');
  
! 	if ( 'media' != $type )
  		$upload_iframe_src = add_query_arg('type', $type, $upload_iframe_src);
  	$upload_iframe_src = apply_filters($type . '_upload_iframe_src', $upload_iframe_src);
  
  	return add_query_arg('TB_iframe', true, $upload_iframe_src);
--- 373,400 ----
   *
   * @since 2.5.0
   */
! function media_buttons($editor_id = 'content') {
  	$context = apply_filters('media_buttons_context', __('Upload/Insert %s'));
  
! 	$img = '<img src="' . esc_url( admin_url( 'images/media-button.png?ver=20111005' ) ) . '" width="15" height="15" />';
! 
! 	echo '<a href="' . esc_url( get_upload_iframe_src() ) . '" class="thickbox add_media" id="' . esc_attr( $editor_id ) . '-add_media" title="' . esc_attr__( 'Add Media' ) . '" onclick="return false;">' . sprintf( $context, $img ) . '</a>';
  }
  add_action( 'media_buttons', 'media_buttons' );
  
! function _media_button($title, $icon, $type, $id) {
! 	return "<a href='" . esc_url( get_upload_iframe_src($type) ) . "' id='{$id}-add_{$type}' class='thickbox add_$type' title='" . esc_attr( $title ) . "'><img src='" . esc_url( admin_url( $icon ) ) . "' alt='$title' onclick='return false;' /></a>";
  }
  
! function get_upload_iframe_src( $type = null ) {
! 	global $post_ID;
! 
! 	$uploading_iframe_ID = (int) $post_ID;
! 	$upload_iframe_src = add_query_arg( 'post_id', $uploading_iframe_ID, admin_url('media-upload.php') );
  
! 	if ( $type && 'media' != $type )
  		$upload_iframe_src = add_query_arg('type', $type, $upload_iframe_src);
+ 
  	$upload_iframe_src = apply_filters($type . '_upload_iframe_src', $upload_iframe_src);
  
  	return add_query_arg('TB_iframe', true, $upload_iframe_src);
***************
*** 516,522 ****
   *
   * @return unknown
   */
! function media_upload_image() {
  	$errors = array();
  	$id = 0;
  
--- 499,507 ----
   *
   * @return unknown
   */
! function wp_media_upload_handler() {
! 	global $is_iphone;
! 
  	$errors = array();
  	$id = 0;
  
***************
*** 532,551 ****
  	}
  
  	if ( !empty($_POST['insertonlybutton']) ) {
! 		$alt = $align = '';
! 
! 		$src = $_POST['insertonly']['src'];
  		if ( !empty($src) && !strpos($src, '://') )
  			$src = "http://$src";
! 		$alt = esc_attr($_POST['insertonly']['alt']);
! 		if ( isset($_POST['insertonly']['align']) ) {
! 			$align = esc_attr($_POST['insertonly']['align']);
! 			$class = " class='align$align'";
  		}
- 		if ( !empty($src) )
- 			$html = "<img src='" . esc_url($src) . "' alt='$alt'$class />";
  
- 		$html = apply_filters('image_send_to_editor_url', $html, esc_url_raw($src), $alt, $align);
  		return media_send_to_editor($html);
  	}
  
--- 517,553 ----
  	}
  
  	if ( !empty($_POST['insertonlybutton']) ) {
! 		$src = $_POST['src'];
  		if ( !empty($src) && !strpos($src, '://') )
  			$src = "http://$src";
! 
! 		if ( isset( $_POST['media_type'] ) && 'image' != $_POST['media_type'] ) {
! 			$title = esc_html( stripslashes( $_POST['title'] ) );
! 			if ( empty( $title ) )
! 				$title = esc_html( basename( $src ) );
! 
! 			if ( $title && $src )
! 				$html = "<a href='" . esc_url($src) . "'>$title</a>";
! 
! 			$type = 'file';
! 			if ( ( $ext = preg_replace( '/^.+?\.([^.]+)$/', '$1', $src ) ) && ( $ext_type = wp_ext2type( $ext ) )
! 				&& ( 'audio' == $ext_type || 'video' == $ext_type ) )
! 					$type = $ext_type;
! 
! 			$html = apply_filters( $type . '_send_to_editor_url', $html, esc_url_raw( $src ), $title );
! 		} else {
! 			$align = '';
! 			$alt = esc_attr( stripslashes( $_POST['alt'] ) );
! 			if ( isset($_POST['align']) ) {
! 				$align = esc_attr( stripslashes( $_POST['align'] ) );
! 				$class = " class='align$align'";
! 			}
! 			if ( !empty($src) )
! 				$html = "<img src='" . esc_url($src) . "' alt='$alt'$class />";
! 
! 			$html = apply_filters( 'image_send_to_editor_url', $html, esc_url_raw( $src ), $alt, $align );
  		}
  
  		return media_send_to_editor($html);
  	}
  
***************
*** 563,572 ****
  		return media_upload_gallery();
  	}
  
! 	if ( isset($_GET['tab']) && $_GET['tab'] == 'type_url' )
! 		return wp_iframe( 'media_upload_type_url_form', 'image', $errors, $id );
  
! 	return wp_iframe( 'media_upload_type_form', 'image', $errors, $id );
  }
  
  /**
--- 565,581 ----
  		return media_upload_gallery();
  	}
  
! 	if ( isset($_GET['tab']) && $_GET['tab'] == 'type_url' ) {
! 		$type = 'image';
! 		if ( isset( $_GET['type'] ) && in_array( $_GET['type'], array( 'video', 'audio', 'file' ) ) )
! 			$type = $_GET['type'];
! 		return wp_iframe( 'media_upload_type_url_form', $type, $errors, $id );
! 	}
  
! 	if ( $is_iphone )
! 		return wp_iframe( 'media_upload_type_url_form', 'image', $errors, $id );
! 	else
! 		return wp_iframe( 'media_upload_type_form', 'image', $errors, $id );
  }
  
  /**
***************
*** 622,801 ****
   *
   * @return unknown
   */
- function media_upload_audio() {
- 	$errors = array();
- 	$id = 0;
- 
- 	if ( isset($_POST['html-upload']) && !empty($_FILES) ) {
- 		check_admin_referer('media-form');
- 		// Upload File button was clicked
- 		$id = media_handle_upload('async-upload', $_REQUEST['post_id']);
- 		unset($_FILES);
- 		if ( is_wp_error($id) ) {
- 			$errors['upload_error'] = $id;
- 			$id = false;
- 		}
- 	}
- 
- 	if ( !empty($_POST['insertonlybutton']) ) {
- 		$href = $_POST['insertonly']['href'];
- 		if ( !empty($href) && !strpos($href, '://') )
- 			$href = "http://$href";
- 
- 		$title = esc_attr($_POST['insertonly']['title']);
- 		if ( empty($title) )
-             $title = esc_attr( basename($href) );
- 
- 		if ( !empty($title) && !empty($href) )
-             $html = "<a href='" . esc_url($href) . "' >$title</a>";
- 
- 		$html = apply_filters('audio_send_to_editor_url', $html, $href, $title);
- 
- 		return media_send_to_editor($html);
- 	}
- 
- 	if ( !empty($_POST) ) {
- 		$return = media_upload_form_handler();
- 
- 		if ( is_string($return) )
- 			return $return;
- 		if ( is_array($return) )
- 			$errors = $return;
- 	}
- 
- 	if ( isset($_POST['save']) ) {
- 		$errors['upload_notice'] = __('Saved.');
- 		return media_upload_gallery();
- 	}
- 
- 	if ( isset($_GET['tab']) && $_GET['tab'] == 'type_url' )
- 		return wp_iframe( 'media_upload_type_url_form', 'audio', $errors, $id );
- 
- 	return wp_iframe( 'media_upload_type_form', 'audio', $errors, $id );
- }
- 
- /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.5.0
-  *
-  * @return unknown
-  */
- function media_upload_video() {
- 	$errors = array();
- 	$id = 0;
- 
- 	if ( isset($_POST['html-upload']) && !empty($_FILES) ) {
- 		check_admin_referer('media-form');
- 		// Upload File button was clicked
- 		$id = media_handle_upload('async-upload', $_REQUEST['post_id']);
- 		unset($_FILES);
- 		if ( is_wp_error($id) ) {
- 			$errors['upload_error'] = $id;
- 			$id = false;
- 		}
- 	}
- 
- 	if ( !empty($_POST['insertonlybutton']) ) {
- 		$href = $_POST['insertonly']['href'];
- 		if ( !empty($href) && !strpos($href, '://') )
- 			$href = "http://$href";
- 
- 		$title = esc_attr($_POST['insertonly']['title']);
-         if ( empty($title) )
-             $title = esc_attr( basename($href) );
- 
- 		if ( !empty($title) && !empty($href) )
-             $html = "<a href='" . esc_url($href) . "' >$title</a>";
- 
- 		$html = apply_filters('video_send_to_editor_url', $html, $href, $title);
- 
- 		return media_send_to_editor($html);
- 	}
- 
- 	if ( !empty($_POST) ) {
- 		$return = media_upload_form_handler();
- 
- 		if ( is_string($return) )
- 			return $return;
- 		if ( is_array($return) )
- 			$errors = $return;
- 	}
- 
- 	if ( isset($_POST['save']) ) {
- 		$errors['upload_notice'] = __('Saved.');
- 		return media_upload_gallery();
- 	}
- 
- 	if ( isset($_GET['tab']) && $_GET['tab'] == 'type_url' )
- 		return wp_iframe( 'media_upload_type_url_form', 'video', $errors, $id );
- 
- 	return wp_iframe( 'media_upload_type_form', 'video', $errors, $id );
- }
- 
- /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.5.0
-  *
-  * @return unknown
-  */
- function media_upload_file() {
- 	$errors = array();
- 	$id = 0;
- 
- 	if ( isset($_POST['html-upload']) && !empty($_FILES) ) {
- 		check_admin_referer('media-form');
- 		// Upload File button was clicked
- 		$id = media_handle_upload('async-upload', $_REQUEST['post_id']);
- 		unset($_FILES);
- 		if ( is_wp_error($id) ) {
- 			$errors['upload_error'] = $id;
- 			$id = false;
- 		}
- 	}
- 
- 	if ( !empty($_POST['insertonlybutton']) ) {
- 		$href = $_POST['insertonly']['href'];
- 		if ( !empty($href) && !strpos($href, '://') )
- 			$href = "http://$href";
- 
- 		$title = esc_attr($_POST['insertonly']['title']);
- 		if ( empty($title) )
- 			$title = basename($href);
- 		if ( !empty($title) && !empty($href) )
- 			$html = "<a href='" . esc_url($href) . "' >$title</a>";
- 		$html = apply_filters('file_send_to_editor_url', $html, esc_url_raw($href), $title);
- 		return media_send_to_editor($html);
- 	}
- 
- 	if ( !empty($_POST) ) {
- 		$return = media_upload_form_handler();
- 
- 		if ( is_string($return) )
- 			return $return;
- 		if ( is_array($return) )
- 			$errors = $return;
- 	}
- 
- 	if ( isset($_POST['save']) ) {
- 		$errors['upload_notice'] = __('Saved.');
- 		return media_upload_gallery();
- 	}
- 
- 	if ( isset($_GET['tab']) && $_GET['tab'] == 'type_url' )
- 		return wp_iframe( 'media_upload_type_url_form', 'file', $errors, $id );
- 
- 	return wp_iframe( 'media_upload_type_form', 'file', $errors, $id );
- }
- 
- /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.5.0
-  *
-  * @return unknown
-  */
  function media_upload_gallery() {
  	$errors = array();
  
--- 631,636 ----
***************
*** 873,879 ****
  function image_size_input_fields( $post, $check = '' ) {
  
  		// get a list of the actual pixel dimensions of each possible intermediate version of this image
! 		$size_names = array('thumbnail' => __('Thumbnail'), 'medium' => __('Medium'), 'large' => __('Large'), 'full' => __('Full Size'));
  
  		if ( empty($check) )
  			$check = get_user_setting('imgsize', 'medium');
--- 708,714 ----
  function image_size_input_fields( $post, $check = '' ) {
  
  		// get a list of the actual pixel dimensions of each possible intermediate version of this image
! 		$size_names = apply_filters( 'image_size_names_choose', array('thumbnail' => __('Thumbnail'), 'medium' => __('Medium'), 'large' => __('Large'), 'full' => __('Full Size')) );
  
  		if ( empty($check) )
  			$check = get_user_setting('imgsize', 'medium');
***************
*** 943,949 ****
  	<input type='text' class='text urlfield' name='attachments[$post->ID][url]' value='" . esc_attr($url) . "' /><br />
  	<button type='button' class='button urlnone' title=''>" . __('None') . "</button>
  	<button type='button' class='button urlfile' title='" . esc_attr($file) . "'>" . __('File URL') . "</button>
! 	<button type='button' class='button urlpost' title='" . esc_attr($link) . "'>" . __('Post URL') . "</button>
  ";
  }
  
--- 778,784 ----
  	<input type='text' class='text urlfield' name='attachments[$post->ID][url]' value='" . esc_attr($url) . "' /><br />
  	<button type='button' class='button urlnone' title=''>" . __('None') . "</button>
  	<button type='button' class='button urlfile' title='" . esc_attr($file) . "'>" . __('File URL') . "</button>
! 	<button type='button' class='button urlpost' title='" . esc_attr($link) . "'>" . __('Attachment Post URL') . "</button>
  ";
  }
  
***************
*** 1181,1187 ****
  		if ( $attachment->post_status == 'trash' )
  			continue;
  		if ( $item = get_media_item( $id, array( 'errors' => isset($errors[$id]) ? $errors[$id] : null) ) )
! 			$output .= "\n<div id='media-item-$id' class='media-item child-of-$attachment->post_parent preloaded'><div class='progress'><div class='bar'></div></div><div id='media-upload-error-$id'></div><div class='filename'></div>$item\n</div>";
  	}
  
  	return $output;
--- 1016,1022 ----
  		if ( $attachment->post_status == 'trash' )
  			continue;
  		if ( $item = get_media_item( $id, array( 'errors' => isset($errors[$id]) ? $errors[$id] : null) ) )
! 			$output .= "\n<div id='media-item-$id' class='media-item child-of-$attachment->post_parent preloaded'><div class='progress hidden'><div class='bar'></div></div><div id='media-upload-error-$id' class='hidden'></div><div class='filename hidden'></div>$item\n</div>";
  	}
  
  	return $output;
***************
*** 1205,1212 ****
  		$thumb_url = false;
  
  	$post = get_post( $attachment_id );
  
! 	$default_args = array( 'errors' => null, 'send' => $post->post_parent ? post_type_supports( get_post_type( $post->post_parent ), 'editor' ) : true, 'delete' => true, 'toggle' => true, 'show_title' => true );
  	$args = wp_parse_args( $args, $default_args );
  	$args = apply_filters( 'get_media_item_args', $args );
  	extract( $args, EXTR_SKIP );
--- 1040,1048 ----
  		$thumb_url = false;
  
  	$post = get_post( $attachment_id );
+ 	$current_post_id = !empty( $_GET['post_id'] ) ? (int) $_GET['post_id'] : 0;
  
! 	$default_args = array( 'errors' => null, 'send' => $current_post_id ? post_type_supports( get_post_type( $current_post_id ), 'editor' ) : true, 'delete' => true, 'toggle' => true, 'show_title' => true );
  	$args = wp_parse_args( $args, $default_args );
  	$args = apply_filters( 'get_media_item_args', $args );
  	extract( $args, EXTR_SKIP );
***************
*** 1236,1242 ****
  	<a class='toggle describe-toggle-on' href='#'>$toggle_on</a>
  	<a class='toggle describe-toggle-off' href='#'>$toggle_off</a>";
  	} else {
! 		$class = 'form-table';
  		$toggle_links = '';
  	}
  
--- 1072,1078 ----
  	<a class='toggle describe-toggle-on' href='#'>$toggle_on</a>
  	<a class='toggle describe-toggle-off' href='#'>$toggle_off</a>";
  	} else {
! 		$class = '';
  		$toggle_links = '';
  	}
  
***************
*** 1281,1287 ****
  		<thead class='media-item-info' id='media-head-$post->ID'>
  		<tr valign='top'>
  			<td class='A1B1' id='thumbnail-head-$post->ID'>
! 			<p><a href='$attachment_url' target='_blank'><img class='thumbnail' src='$thumb_url' alt='' style='margin-top: 3px' /></a></p>
  			<p>$image_edit_button</p>
  			</td>
  			<td>
--- 1117,1123 ----
  		<thead class='media-item-info' id='media-head-$post->ID'>
  		<tr valign='top'>
  			<td class='A1B1' id='thumbnail-head-$post->ID'>
! 			<p><a href='$attachment_url' target='_blank'><img class='thumbnail' src='$thumb_url' alt='' /></a></p>
  			<p>$image_edit_button</p>
  			</td>
  			<td>
***************
*** 1333,1339 ****
  		$calling_post_id = absint( $_GET['post_id'] );
  	elseif ( isset( $_POST ) && count( $_POST ) ) // Like for async-upload where $_GET['post_id'] isn't set
  		$calling_post_id = $post->post_parent;
! 	if ( 'image' == $type && $calling_post_id && current_theme_supports( 'post-thumbnails', get_post_type( $calling_post_id ) ) && get_post_thumbnail_id( $calling_post_id ) != $attachment_id ) {
  		$ajax_nonce = wp_create_nonce( "set_post_thumbnail-$calling_post_id" );
  		$thumbnail = "<a class='wp-post-thumbnail' id='wp-post-thumbnail-" . $attachment_id . "' href='#' onclick='WPSetAsThumbnail(\"$attachment_id\", \"$ajax_nonce\");return false;'>" . esc_html__( "Use as featured image" ) . "</a>";
  	}
--- 1169,1176 ----
  		$calling_post_id = absint( $_GET['post_id'] );
  	elseif ( isset( $_POST ) && count( $_POST ) ) // Like for async-upload where $_GET['post_id'] isn't set
  		$calling_post_id = $post->post_parent;
! 	if ( 'image' == $type && $calling_post_id && current_theme_supports( 'post-thumbnails', get_post_type( $calling_post_id ) )
! 		&& post_type_supports( get_post_type( $calling_post_id ), 'thumbnail' ) && get_post_thumbnail_id( $calling_post_id ) != $attachment_id ) {
  		$ajax_nonce = wp_create_nonce( "set_post_thumbnail-$calling_post_id" );
  		$thumbnail = "<a class='wp-post-thumbnail' id='wp-post-thumbnail-" . $attachment_id . "' href='#' onclick='WPSetAsThumbnail(\"$attachment_id\", \"$ajax_nonce\");return false;'>" . esc_html__( "Use as featured image" ) . "</a>";
  	}
***************
*** 1435,1456 ****
   * @param unknown_type $errors
   */
  function media_upload_form( $errors = null ) {
! 	global $type, $tab, $pagenow;
! 
! 	$flash_action_url = admin_url('async-upload.php');
  
! 	// If Mac and mod_security, no Flash. :(
! 	$flash = true;
! 	if ( false !== stripos($_SERVER['HTTP_USER_AGENT'], 'mac') && apache_mod_loaded('mod_security') )
! 		$flash = false;
  
! 	$flash = apply_filters('flash_uploader', $flash);
  	$post_id = isset($_REQUEST['post_id']) ? intval($_REQUEST['post_id']) : 0;
  
! 	$upload_size_unit = $max_upload_size =  wp_max_upload_size();
  	$sizes = array( 'KB', 'MB', 'GB' );
! 	for ( $u = -1; $upload_size_unit > 1024 && $u < count( $sizes ) - 1; $u++ )
  		$upload_size_unit /= 1024;
  	if ( $u < 0 ) {
  		$upload_size_unit = 0;
  		$u = 0;
--- 1272,1294 ----
   * @param unknown_type $errors
   */
  function media_upload_form( $errors = null ) {
! 	global $type, $tab, $pagenow, $is_IE, $is_opera, $is_iphone;
  
! 	if ( $is_iphone )
! 		return;
  
! 	$upload_action_url = admin_url('async-upload.php');
  	$post_id = isset($_REQUEST['post_id']) ? intval($_REQUEST['post_id']) : 0;
+ 	$_type = isset($type) ? $type : '';
+ 	$_tab = isset($tab) ? $tab : '';
  
! 	$upload_size_unit = $max_upload_size = wp_max_upload_size();
  	$sizes = array( 'KB', 'MB', 'GB' );
! 
! 	for ( $u = -1; $upload_size_unit > 1024 && $u < count( $sizes ) - 1; $u++ ) {
  		$upload_size_unit /= 1024;
+ 	}
+ 
  	if ( $u < 0 ) {
  		$upload_size_unit = 0;
  		$u = 0;
***************
*** 1458,1483 ****
  		$upload_size_unit = (int) $upload_size_unit;
  	}
  ?>
! <script type="text/javascript">
! //<![CDATA[
! var uploaderMode = 0;
! jQuery(document).ready(function($){
! 	uploaderMode = getUserSetting('uploader');
! 	$('.upload-html-bypass a').click(function(){deleteUserSetting('uploader');uploaderMode=0;swfuploadPreLoad();return false;});
! 	$('.upload-flash-bypass a').click(function(){setUserSetting('uploader', '1');uploaderMode=1;swfuploadPreLoad();return false;});
! });
! //]]>
! </script>
! <div id="media-upload-notice">
! <?php if (isset($errors['upload_notice']) ) { ?>
! 	<?php echo $errors['upload_notice']; ?>
! <?php } ?>
! </div>
! <div id="media-upload-error">
! <?php if (isset($errors['upload_error']) && is_wp_error($errors['upload_error'])) { ?>
! 	<?php echo $errors['upload_error']->get_error_message(); ?>
! <?php } ?>
! </div>
  <?php
  // Check quota for this blog if multisite
  if ( is_multisite() && !is_upload_space_available() ) {
--- 1296,1314 ----
  		$upload_size_unit = (int) $upload_size_unit;
  	}
  ?>
! 
! <div id="media-upload-notice"><?php
! 
! 	if (isset($errors['upload_notice']) )
! 		echo $errors['upload_notice'];
! 
! ?></div>
! <div id="media-upload-error"><?php
! 
! 	if (isset($errors['upload_error']) && is_wp_error($errors['upload_error']))
! 		echo $errors['upload_error']->get_error_message();
! 
! ?></div>
  <?php
  // Check quota for this blog if multisite
  if ( is_multisite() && !is_upload_space_available() ) {
***************
*** 1487,1579 ****
  
  do_action('pre-upload-ui');
  
- if ( $flash ) :
- 
- // Set the post params, which SWFUpload will post back with the file, and pass
- // them through a filter.
  $post_params = array(
  		"post_id" => $post_id,
- 		"auth_cookie" => (is_ssl() ? $_COOKIE[SECURE_AUTH_COOKIE] : $_COOKIE[AUTH_COOKIE]),
- 		"logged_in_cookie" => $_COOKIE[LOGGED_IN_COOKIE],
  		"_wpnonce" => wp_create_nonce('media-form'),
! 		"type" => $type,
! 		"tab" => $tab,
  		"short" => "1",
  );
! $post_params = apply_filters( 'swfupload_post_params', $post_params );
! $p = array();
! foreach ( $post_params as $param => $val )
! 	$p[] = "\t\t'$param' : '$val'";
! $post_params_str = implode( ", \n", $p );
! 
! // #8545. wmode=transparent cannot be used with SWFUpload
! if ( 'media-new.php' == $pagenow ) {
! 	$upload_image_path = get_user_option( 'admin_color' );
! 	if ( 'classic' != $upload_image_path )
! 		$upload_image_path = 'fresh';
! 	$upload_image_path = admin_url( 'images/upload-' . $upload_image_path . '.png?ver=20101205' );
! } else {
! 	$upload_image_path = includes_url( 'images/upload.png?ver=20100531' );
! }
  
  ?>
  <script type="text/javascript">
! //<![CDATA[
! var swfu;
! SWFUpload.onload = function() {
! 	var settings = {
! 			button_text: '<span class="button"><?php _e('Select Files'); ?><\/span>',
! 			button_text_style: '.button { text-align: center; font-weight: bold; font-family:"Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; font-size: 11px; text-shadow: 0 1px 0 #FFFFFF; color:#464646; }',
! 			button_height: "23",
! 			button_width: "132",
! 			button_text_top_padding: 3,
! 			button_image_url: '<?php echo $upload_image_path; ?>',
! 			button_placeholder_id: "flash-browse-button",
! 			upload_url : "<?php echo esc_attr( $flash_action_url ); ?>",
! 			flash_url : "<?php echo includes_url('js/swfupload/swfupload.swf'); ?>",
! 			file_post_name: "async-upload",
! 			file_types: "<?php echo apply_filters('upload_file_glob', '*.*'); ?>",
! 			post_params : {
! 				<?php echo $post_params_str; ?>
! 			},
! 			file_size_limit : "<?php echo $max_upload_size; ?>b",
! 			file_dialog_start_handler : fileDialogStart,
! 			file_queued_handler : fileQueued,
! 			upload_start_handler : uploadStart,
! 			upload_progress_handler : uploadProgress,
! 			upload_error_handler : uploadError,
! 			upload_success_handler : <?php echo apply_filters( 'swfupload_success_handler', 'uploadSuccess' ); ?>,
! 			upload_complete_handler : uploadComplete,
! 			file_queue_error_handler : fileQueueError,
! 			file_dialog_complete_handler : fileDialogComplete,
! 			swfupload_pre_load_handler: swfuploadPreLoad,
! 			swfupload_load_failed_handler: swfuploadLoadFailed,
! 			custom_settings : {
! 				degraded_element_id : "html-upload-ui", // id of the element displayed when swfupload is unavailable
! 				swfupload_element_id : "flash-upload-ui" // id of the element displayed when swfupload is available
! 			},
! 			debug: false
! 		};
! 		swfu = new SWFUpload(settings);
! };
! //]]>
  </script>
  
! <div id="flash-upload-ui" class="hide-if-no-js">
! <?php do_action('pre-flash-upload-ui'); ?>
! 
! 	<div>
! 	<?php _e( 'Choose files to upload' ); ?>
! 	<div id="flash-browse-button"></div>
! 	<span><input id="cancel-upload" disabled="disabled" onclick="cancelUpload()" type="button" value="<?php esc_attr_e('Cancel Upload'); ?>" class="button" /></span>
  	</div>
- 	<p class="media-upload-size"><?php printf( __( 'Maximum upload file size: %d%s' ), $upload_size_unit, $sizes[$u] ); ?></p>
- <?php do_action('post-flash-upload-ui'); ?>
- 	<p class="howto"><?php _e('After a file has been uploaded, you can add titles and descriptions.'); ?></p>
  </div>
! <?php endif; // $flash ?>
  
! <div id="html-upload-ui" <?php if ( $flash ) echo 'class="hide-if-js"'; ?>>
  <?php do_action('pre-html-upload-ui'); ?>
  	<p id="async-upload-wrap">
  		<label class="screen-reader-text" for="async-upload"><?php _e('Upload'); ?></label>
--- 1318,1381 ----
  
  do_action('pre-upload-ui');
  
  $post_params = array(
  		"post_id" => $post_id,
  		"_wpnonce" => wp_create_nonce('media-form'),
! 		"type" => $_type,
! 		"tab" => $_tab,
  		"short" => "1",
  );
! 
! $post_params = apply_filters( 'upload_post_params', $post_params ); // hook change! old name: 'swfupload_post_params'
! 
! $plupload_init = array(
! 	'runtimes' => 'html5,silverlight,flash,html4',
! 	'browse_button' => 'plupload-browse-button',
! 	'container' => 'plupload-upload-ui',
! 	'drop_element' => 'drag-drop-area',
! 	'file_data_name' => 'async-upload',
! 	'multiple_queues' => true,
! 	'max_file_size' => $max_upload_size . 'b',
! 	'url' => $upload_action_url,
! 	'flash_swf_url' => includes_url('js/plupload/plupload.flash.swf'),
! 	'silverlight_xap_url' => includes_url('js/plupload/plupload.silverlight.xap'),
! 	'filters' => array( array('title' => __( 'Allowed Files' ), 'extensions' => '*') ),
! 	'multipart' => true,
! 	'urlstream_upload' => true,
! 	'multipart_params' => $post_params
! );
! 
! $plupload_init = apply_filters( 'plupload_init', $plupload_init );
  
  ?>
+ 
  <script type="text/javascript">
! <?php
! // Verify size is an int. If not return default value.
! $large_size_h = absint( get_option('large_size_h') );
! if( !$large_size_h )
! 	$large_size_h = 1024;
! $large_size_w = absint( get_option('large_size_w') );
! if( !$large_size_w )
! 	$large_size_w = 1024;
! ?>
! var resize_height = <?php echo $large_size_h; ?>, resize_width = <?php echo $large_size_w; ?>,
! wpUploaderInit = <?php echo json_encode($plupload_init); ?>;
  </script>
  
! <div id="plupload-upload-ui" class="hide-if-no-js">
! <?php do_action('pre-plupload-upload-ui'); // hook change, old name: 'pre-flash-upload-ui' ?>
! <div id="drag-drop-area">
! 	<div class="drag-drop-inside">
! 	<p class="drag-drop-info"><?php _e('Drop files here'); ?></p>
! 	<p><?php _ex('or', 'Uploader: Drop files here - or - Select Files'); ?></p>
! 	<p class="drag-drop-buttons"><input id="plupload-browse-button" type="button" value="<?php esc_attr_e('Select Files'); ?>" class="button" /></p>
  	</div>
  </div>
! <?php do_action('post-plupload-upload-ui'); // hook change, old name: 'post-flash-upload-ui' ?>
! </div>
  
! <div id="html-upload-ui" class="hide-if-js">
  <?php do_action('pre-html-upload-ui'); ?>
  	<p id="async-upload-wrap">
  		<label class="screen-reader-text" for="async-upload"><?php _e('Upload'); ?></label>
